// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license. 

#include <string>
#include <stdlib.h>
#include <filesystem>
#include <future>
#include "SimplygonLoader.h"


void RunRemeshing(Simplygon::ISimplygon* sg)
{
	Simplygon::spSceneImporter sgSceneImporter = sg->CreateSceneImporter();
	sgSceneImporter->SetImportFilePath( "../Assets/RiggedSimplygonMan/RiggedSimplygonMan.fbx" );
	if(!sgSceneImporter->RunImport())
		throw std::exception("Failed to load RiggedSimplygonMan/RiggedSimplygonMan.fbx.");
	Simplygon::spScene sgScene = sgSceneImporter->GetScene();

	// Create the remeshing pipeline. 
	Simplygon::spRemeshingPipeline sgRemeshingPipeline = sg->CreateRemeshingPipeline();

	Simplygon::spRemeshingSettings sgRemeshingSettings = sgRemeshingPipeline->GetRemeshingSettings();
	Simplygon::spBoneSettings sgBoneSettings = sgRemeshingPipeline->GetBoneSettings();

	// Set on-screen size target for remeshing. 
	sgRemeshingSettings->SetOnScreenSize( 300 );

	// Enable bone reducer. 
	sgBoneSettings->SetUseBoneReducer( true );

	// Set bone reduction target to bone ratio with a ratio of 50%. 
	sgBoneSettings->SetBoneReductionTargets( Simplygon::EStopCondition::All, true, false, false, false );
	sgBoneSettings->SetBoneReductionTargetBoneRatio( 0.5f );

	// Set bones per vertex limitations. 
	sgBoneSettings->SetLimitBonesPerVertex( true );
	sgBoneSettings->SetMaxBonePerVertex( 64 );

	// Remove unused bones. 
	sgBoneSettings->SetRemoveUnusedBones( true );

	// Start the remeshing pipeline. 
	sgRemeshingPipeline->RunScene(sgScene, Simplygon::EPipelineRunMode::RunInThisProcess);

	// Get the processed scene. 
	Simplygon::spScene sgProcessedScene = sgRemeshingPipeline->GetProcessedScene();

	Simplygon::spSceneExporter  sgSceneExporter = sg->CreateSceneExporter();
	sgSceneExporter->SetScene(sgProcessedScene);
	sgSceneExporter->SetExportFilePath( "RemeshingOutput.fbx" );
	if(!sgSceneExporter->RunExport())
		throw std::exception("Failed to save RemeshingOutput.fbx.");

}

void main()
{
	Simplygon::ISimplygon* sg = NULL;
	Simplygon::EErrorCodes initval = Simplygon::Initialize( &sg );
	if( initval != Simplygon::EErrorCodes::NoError )
	{
		return;
	}

	RunRemeshing(sg);

	Simplygon::Deinitialize(sg);
}

